'use client';
import { jsx } from 'react/jsx-runtime';
import { NumericFormat } from 'react-number-format';
import { T as TextField } from './TextField-client-DtfoZ3Q7.js';

/**
 * `NumberField` 元件代表一個數字輸入框，繼承自 `TextField`。
 *
 * 參考 [React Number Format](https://s-yadav.github.io/react-number-format/)
 */ const NumberField = (props)=>{
    const { inputRef, onChange, ...other } = props;
    return /*#__PURE__*/ jsx(NumericFormat, {
        ...other,
        customInput: TextField,
        getInputRef: inputRef
    });
};

export { NumberField as N };
