'use client';
var jsxRuntime = require('react/jsx-runtime');
var reactNumberFormat = require('react-number-format');
var TextFieldClient = require('./TextField-client-qgsFFXa9.js');

/**
 * `NumberField` 元件代表一個數字輸入框，繼承自 `TextField`。
 *
 * 參考 [React Number Format](https://s-yadav.github.io/react-number-format/)
 */ const NumberField = (props)=>{
    const { inputRef, onChange, ...other } = props;
    return /*#__PURE__*/ jsxRuntime.jsx(reactNumberFormat.NumericFormat, {
        ...other,
        customInput: TextFieldClient.TextField,
        getInputRef: inputRef
    });
};

exports.NumberField = NumberField;
